﻿// <auto-generated />
using System;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Migrations;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;
using api.Entities;

namespace api.Migrations
{
    [DbContext(typeof(ApiContext))]
    [Migration("20220602062744_SetRequiredForUser")]
    partial class SetRequiredForUser
    {
        protected override void BuildTargetModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("Relational:MaxIdentifierLength", 63)
                .HasAnnotation("ProductVersion", "5.0.12")
                .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

            modelBuilder.Entity("api.Entities.AlgorithmType", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int>("ExecutionTime")
                        .HasColumnType("integer")
                        .HasColumnName("execution_time");

                    b.Property<int>("MaxFailedSteps")
                        .HasColumnType("integer")
                        .HasColumnName("max_failed_steps");

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_algorithm_types");

                    b.ToTable("algorithm_types");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            ExecutionTime = 20,
                            MaxFailedSteps = 3,
                            Name = "BubbleSort"
                        },
                        new
                        {
                            Id = 2,
                            ExecutionTime = 20,
                            MaxFailedSteps = 3,
                            Name = "SelectionSort"
                        },
                        new
                        {
                            Id = 3,
                            ExecutionTime = 20,
                            MaxFailedSteps = 3,
                            Name = "InsertionSort"
                        },
                        new
                        {
                            Id = 4,
                            ExecutionTime = 20,
                            MaxFailedSteps = 3,
                            Name = "MergeSort"
                        });
                });

            modelBuilder.Entity("api.Entities.ExecutionResult", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int>("AlgorithmTypeId")
                        .HasColumnType("integer")
                        .HasColumnName("algorithm_type_id");

                    b.Property<int>("ExecutionStatusId")
                        .HasColumnType("integer")
                        .HasColumnName("execution_status_id");

                    b.Property<TimeSpan>("ExecutionTime")
                        .HasColumnType("interval")
                        .HasColumnName("execution_time");

                    b.Property<int>("Mark")
                        .HasColumnType("integer")
                        .HasColumnName("mark");

                    b.Property<int>("UserId")
                        .HasColumnType("integer")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_execution_results");

                    b.HasIndex("AlgorithmTypeId")
                        .HasDatabaseName("ix_execution_results_algorithm_type_id");

                    b.HasIndex("ExecutionStatusId")
                        .IsUnique()
                        .HasDatabaseName("ix_execution_results_execution_status_id");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_execution_results_user_id");

                    b.ToTable("execution_results");
                });

            modelBuilder.Entity("api.Entities.ExecutionStatus", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<int>("AlgorithmTypeId")
                        .HasColumnType("integer")
                        .HasColumnName("algorithm_type_id");

                    b.Property<string>("CorrectSortSteps")
                        .HasColumnType("text")
                        .HasColumnName("correct_sort_steps");

                    b.Property<int>("CurrentStep")
                        .HasColumnType("integer")
                        .HasColumnName("current_step");

                    b.Property<DateTime>("ExpiredAt")
                        .HasColumnType("timestamp without time zone")
                        .HasColumnName("expired_at");

                    b.Property<int>("FailedStepAmount")
                        .HasColumnType("integer")
                        .HasColumnName("failed_step_amount");

                    b.Property<bool>("IsTestExecution")
                        .HasColumnType("boolean")
                        .HasColumnName("is_test_execution");

                    b.Property<DateTime>("StartedAt")
                        .HasColumnType("timestamp without time zone")
                        .HasColumnName("started_at");

                    b.Property<DateTime>("UpdateAt")
                        .HasColumnType("timestamp without time zone")
                        .HasColumnName("update_at");

                    b.HasKey("Id")
                        .HasName("pk_execution_statuses");

                    b.HasIndex("AlgorithmTypeId")
                        .HasDatabaseName("ix_execution_statuses_algorithm_type_id");

                    b.ToTable("execution_statuses");
                });

            modelBuilder.Entity("api.Entities.User", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<bool>("CanDoOfficialExecution")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("boolean")
                        .HasDefaultValue(false)
                        .HasColumnName("can_do_official_execution");

                    b.Property<int?>("ExecutionStatusId")
                        .HasColumnType("integer")
                        .HasColumnName("execution_status_id");

                    b.Property<string>("FirstName")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("first_name");

                    b.Property<string>("Lastname")
                        .HasColumnType("text")
                        .HasColumnName("lastname");

                    b.Property<string>("Login")
                        .HasColumnType("text")
                        .HasColumnName("login");

                    b.Property<string>("MiddleName")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("middle_name");

                    b.Property<string>("Password")
                        .HasColumnType("text")
                        .HasColumnName("password");

                    b.Property<int>("RoleId")
                        .HasColumnType("integer")
                        .HasColumnName("role_id");

                    b.HasKey("Id")
                        .HasName("pk_users");

                    b.HasIndex("ExecutionStatusId")
                        .IsUnique()
                        .HasDatabaseName("ix_users_execution_status_id");

                    b.HasIndex("RoleId")
                        .HasDatabaseName("ix_users_role_id");

                    b.ToTable("users");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            CanDoOfficialExecution = true,
                            FirstName = "Admin",
                            Login = "admin",
                            MiddleName = "Admin",
                            Password = "$2a$11$pwEI.UdPcG9GMNuHVmC.K.bPegzFFFYuSgASsZ4ehF3DF3zadTA32",
                            RoleId = 1
                        });
                });

            modelBuilder.Entity("api.Entities.UserRole", b =>
                {
                    b.Property<int>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("integer")
                        .HasColumnName("id")
                        .HasAnnotation("Npgsql:ValueGenerationStrategy", NpgsqlValueGenerationStrategy.IdentityByDefaultColumn);

                    b.Property<string>("Name")
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.HasKey("Id")
                        .HasName("pk_user_roles");

                    b.ToTable("user_roles");

                    b.HasData(
                        new
                        {
                            Id = 1,
                            Name = "admin"
                        },
                        new
                        {
                            Id = 2,
                            Name = "teacher"
                        },
                        new
                        {
                            Id = 3,
                            Name = "student"
                        });
                });

            modelBuilder.Entity("api.Entities.ExecutionResult", b =>
                {
                    b.HasOne("api.Entities.AlgorithmType", "AlgorithmType")
                        .WithMany("ExecutionResults")
                        .HasForeignKey("AlgorithmTypeId")
                        .HasConstraintName("fk_execution_results_algorithm_types_algorithm_type_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("api.Entities.ExecutionStatus", "ExecutionStatus")
                        .WithOne("ExecutionResult")
                        .HasForeignKey("api.Entities.ExecutionResult", "ExecutionStatusId")
                        .HasConstraintName("fk_execution_results_execution_statuses_execution_status_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.HasOne("api.Entities.User", "User")
                        .WithMany("ExecutionResults")
                        .HasForeignKey("UserId")
                        .HasConstraintName("fk_execution_results_users_user_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AlgorithmType");

                    b.Navigation("ExecutionStatus");

                    b.Navigation("User");
                });

            modelBuilder.Entity("api.Entities.ExecutionStatus", b =>
                {
                    b.HasOne("api.Entities.AlgorithmType", "AlgorithmType")
                        .WithMany("ExecutionStatuses")
                        .HasForeignKey("AlgorithmTypeId")
                        .HasConstraintName("fk_execution_statuses_algorithm_types_algorithm_type_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("AlgorithmType");
                });

            modelBuilder.Entity("api.Entities.User", b =>
                {
                    b.HasOne("api.Entities.ExecutionStatus", "ExecutionStatus")
                        .WithOne("User")
                        .HasForeignKey("api.Entities.User", "ExecutionStatusId")
                        .HasConstraintName("fk_users_execution_statuses_execution_status_id");

                    b.HasOne("api.Entities.UserRole", "Role")
                        .WithMany("Users")
                        .HasForeignKey("RoleId")
                        .HasConstraintName("fk_users_user_roles_role_id")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired();

                    b.Navigation("ExecutionStatus");

                    b.Navigation("Role");
                });

            modelBuilder.Entity("api.Entities.AlgorithmType", b =>
                {
                    b.Navigation("ExecutionResults");

                    b.Navigation("ExecutionStatuses");
                });

            modelBuilder.Entity("api.Entities.ExecutionStatus", b =>
                {
                    b.Navigation("ExecutionResult");

                    b.Navigation("User");
                });

            modelBuilder.Entity("api.Entities.User", b =>
                {
                    b.Navigation("ExecutionResults");
                });

            modelBuilder.Entity("api.Entities.UserRole", b =>
                {
                    b.Navigation("Users");
                });
#pragma warning restore 612, 618
        }
    }
}
